﻿-- --------------------
-- TellMeWhen
-- Originally by Nephthys of Hyjal <lieandswell@yahoo.com>
-- Other contributions by
-- Oozebull of Twisting Nether
-- Banjankri of Blackrock
-- Predeter of Proudmoore
-- Xenyr of Aszune
-- Cybeloras of Mal'Ganis
-- --------------------

-- -------------
-- ADDON GLOBALS AND LOCALS
-- -------------

TMW = {...};
local TMW = TMW
TMW.Initd = false
TMW.Warns = {}
TMW.Icons = {}

TELLMEWHEN_VERSION = "2.2.1";
TELLMEWHEN_VERSION_MINOR = "";
TELLMEWHEN_MAXOLDGROUPS = 8; --NEVER CHANGE THIS EVER EVER EVER
TELLMEWHEN_MAXGROUPS = 10;
TELLMEWHEN_MAXROWS = 7;
TELLMEWHEN_MAXCONDITIONS = 3; --this is a default
TELLMEWHEN_ICONSPACING = 0;	--this is a default
local TELLMEWHEN_UPDATE_INTERVAL = 0.05;	--this is a default, local because i use it in onupdate functions


local oldp = print
local function print(...)
	if TMW.TestOn then
		oldp("|cffff0000TMW:|r ", ...)
	end
end

local L = LibStub("AceLocale-3.0"):GetLocale("TellMeWhen", true)
local LBF = LibStub("LibButtonFacade", true)

local GetSpellCooldown, GetSpellInfo, IsUsableSpell, IsSpellInRange = GetSpellCooldown, GetSpellInfo, IsUsableSpell, IsSpellInRange;
local GetItemCooldown, IsItemInRange = GetItemCooldown, IsItemInRange;
local GetInventorySlotInfo, GetWeaponEnchantInfo, GetTotemInfo = GetInventorySlotInfo, GetWeaponEnchantInfo, GetTotemInfo;
local CooldownFrame_SetTimer, GetSpellTexture = CooldownFrame_SetTimer, GetSpellTexture;
local SetValue, SetTexCoord, SetStatusBarColor, SetMinMaxValues = SetValue, SetTexCoord, SetStatusBarColor, SetMinMaxValues;
local SetVertexColor, SetAlpha, GetAlpha, GetTexture, SetTexture = SetVertexColor, SetAlpha, GetAlpha, GetTexture, SetTexture;
local UnitIsEnemy, UnitAura, UnitReaction, UnitExists, UnitPower, UnitHealth, UnitIsDeadOrGhost = UnitIsEnemy, UnitAura, UnitReaction, UnitExists, UnitPower, UnitHealth, UnitIsDeadOrGhost;
local GetPetHappiness, GetEclipseDirection, GetComboPoints = GetPetHappiness, GetEclipseDirection, GetComboPoints;
local GetActionCooldown, GetActionInfo, IsActionInRange, IsUsableAction = GetActionCooldown, GetActionInfo, IsActionInRange, IsUsableAction;
local tonumber, tostring, type, strfind, strmatch, format, gsub = tonumber, tostring, type, strfind, strmatch, format, gsub
local _G = _G

local _,pclass = UnitClass("Player")
local st, co, rc, mc, us, un, pr, ab, GCDSpell, id
local chakra,TMW_CNDT,TMW_OP,TMW_AO = {},{},{},{},{},{}


TMW.Icon_Defaults = { --NEVER EVER EVER CHANGE ANY OF THESE OR ALL USER'S SETTINGS GET OWNED
	BuffOrDebuff		= "HELPFUL",
	BuffShowWhen		= "present",
	CooldownShowWhen	= "usable",
	CooldownType		= "spell",
	Enabled				= false,
	Name				= "",
	OnlyMine			= false,
	ShowTimer			= false,
	ShowTimerText		= true,
	ShowPBar			= false,
	ShowCBar			= false,
	InvertBars			= false,
	Type				= "",
	Unit				= "player",
	WpnEnchantType		= "MainHandSlot",
	Conditions			= {},
	Alpha				= 1,
	UnAlpha				= 1,
	ConditionAlpha		= 0,
	RangeCheck			= false,
	ManaCheck			= false,
	CooldownCheck		= false,
	StackMin			= 0,
	StackMax			= 100,
	FakeHidden			= false,
	Slot				= 100,
	HideUnequipped		= false,
};

TMW.Condition_Defaults = {
	AndOr = "AND",
	Type = "HEALTH",
	Icon = "",
	Operator = "==",
	Level = 0,
	Unit = "player",
}

TMW.Icon_DeletedSettings = { --Add obsolete settings here and run TellMeWhen_CondenseSettings()
	OORColor = true,
	OOMColor = true,
	Color = true,
	ColorOverride = true,
	UnColor = true,
	DurationAndCD = true,
	Shapeshift = true, -- i used this one during some initial testing for shapeshifts
}

TMW.Group_Defaults = {
	Enabled			= false,
	Scale			= 2.0,
	Rows			= 1,
	Columns			= 4,
	Icons			= {},
	OnlyInCombat	= false,
	PrimarySpec		= true,
	SecondarySpec	= true,
	Stance			= {},
	Point			= {},
	LBF				= {},
};

TMW.Defaults = {
	Version 		= 	TELLMEWHEN_VERSION,
	Locked 			= 	false,
	Groups 			= 	{},
	Interval		=	TELLMEWHEN_UPDATE_INTERVAL,
	CDCOColor 		= 	{r=0,g=1,b=0,a=1},
	CDSTColor 		= 	{r=1,g=0,b=0,a=1},
	USEColor		=	{r=1,g=1,b=1,a=1},
	UNUSEColor		=	{r=1,g=1,b=1,a=1},
	PRESENTColor	=	{r=1,g=1,b=1,a=1},
	ABSENTColor		=	{r=1,g=0.35,b=0.35,a=1},
	OORColor		=	{r=0.5,g=0.5,b=0.5,a=1},
	OOMColor		=	{r=0.5,g=0.5,b=0.5,a=1},
	NumCondits 		= 	TELLMEWHEN_MAXCONDITIONS,
	Spacing			=	TELLMEWHEN_ICONSPACING,
	Texture			=	"Interface\\TargetingFrame\\UI-StatusBar",
	TextureName 	= 	"Blizzard",
	DrawEdge		=	false,
	TestOn 			= 	false,
	Font 			= 	{
							Path = "Fonts\\ARIALN.TTF",
							Name = "Arial Narrow",
							Size = 12,
							Outline = "THICK",
						},
};

--Much of these are thanks to Malazee @ Petopia's chart: http://img204.imageshack.us/img204/4902/cataraiTellMeWhen_Settingsuffs.jpg and spreadsheet https://spreadsheets.google.com/ccc?key=0Aox2ZHZE6e_SdHhTc0tZam05QVJDU0lONnp0ZVgzdkE&hl=en#gid=18
TMW.BE = {
	debuffs = {
		["CrowdControl"] = "339;2637;33786;118;61305;28272;61721;61780;28271;1499;60192;19503;19386;20066;10326;9484;6770;2094;51514;76780;710;5782;6358", -- by calico0 of Curse
		["Bleeding"] = "9007;1822;1079;33745;1943;703;94009;43104",
		["Incapacitated"] = "1776;20066;49203",
		["Feared"] = "5782;5246;8122;10326;1513;5484;6789",
		["StunnedOrIncapacitated"] = "1833;408;91800;5211;9005;22570;19577;56626;44572;82691;853;2812;64044;20549;46968;30283;20252;65929;7922;12809;50519;1776;20066;49203",
		["Stunned"] = "1833;408;91800;5211;9005;22570;19577;56626;44572;82691;90337;853;2812;64044;20549;46968;30283;20252;65929;7922;12809;50519",
		--["DontMelee"] = "5277;871;Retaliation;Dispersion;Hand of Sacrifice;Hand of Protection;Divine Shield;Divine Protection;Ice Block;Icebound Fortitude;Cyclone;Banish",  --does somebody want to update these for me?
		--["MovementSlowed"] = "Incapacitating Shout;Chains of Ice;Icy Clutch;Slow;Daze;Hamstring;Piercing Howl;Wing Clip;Ice Trap;Frostbolt;Cone of Cold;Blast Wave;Mind Flay;Crippling Poison;Deadly Throw;Frost Shock;Earthbind;Curse of Exhaustion",
		["Disoriented"] = "19503;31661;2094;51514",
		["Silenced"] = "47476;78675;34490;55021;18469;31935;15487;1330;19647;18498;25046;80483;50613;28730;69179",
		["Disarmed"] = "51722;676;64058;50541;91644",
		["Rooted"] = "122;23694;58373;64695;19185;64803;4167;54706;50245;90327;16979;83301;83302",
		["PhysicalDmgTaken"] = "30070;58683;81326;50518;55749",
		["SpellDamageTaken"] = "93068;1490;65142;60433;34889;24844",
		["SpellCritTaken"] = "17800;22959",
		["BleedDamageTaken"] = "33878;33876;16511;46857;50271;35290;57386",
		["ReducedAttackSpeed"] = "6343;55095;58180;68055;8042;90314;50285",
		["ReducedCastingSpeed"] = "1714;5760;31589;73975;50274;50498",
		["ReducedArmor"] = "8647;50498;35387;91565;7386",
		["ReducedHealing"] = "12294;13218;56112;48301;82654;30213;54680",
		["ReducedPhysicalDone"] = "1160;99;26017;81130;702;24423",
	},
	buffs = {
		["ImmuneToStun"] = "642;45438;34471;19574;48792;1022;33786;710",
		["ImmuneToMagicCC"] = "642;45438;34471;19574;33786;710",
		["IncreasedStats"] = "79061;79063;90363",
		["IncreasedDamage"] = "75447;82930",
		["IncreasedCrit"] = "24932;29801;51701;51470;24604;90309",
		["IncreasedAP"] = "79102;53138;19506;30808",
		["IncreasedSPsix"] = "79058;52109",
		["IncreasedSPten"] = "77747;53646",
		["IncreasedSPboth"] = "79058;52109;77747;53646",
		["IncreasedPhysHaste"] = "55610;53290;8515",
		["IncreasedSpellHaste"] = "2895;24907;49868",
		["BurstHaste"] = "2825;32182;80353;90355",
		["BonusAgiStr"] = "6673;8076;57330;93435",
		["BonusStamina"] = "79105;469;6307;90364",
		["BonusArmor"] = "465;8072",
		["BonusMana"] = "79058;54424",
		["ManaRegen"] = "54424;79102;5677",
		["BurstManaRegen"] = "29166;16191;64901",
		["PushbackResistance"] = "19746;87717",
		["Resistances"] = "19891;8185",
	},
};


-- ---------------
-- EXECUTIVE FRAME
-- ---------------

if LBF then
	LBF:RegisterSkinCallback("TellMeWhen", TellMeWhen_SkinCallback, self);
end

function TellMeWhen_OnEvent(self, event,...)
	if ( event == "ADDON_LOADED" ) and ... == TMW[1] then
		TellMeWhen_VarsLoaded()
		TellMeWhen_Update();
	elseif ( event == "PLAYER_LOGIN" ) or ( event == "PLAYER_ENTERING_WORLD" ) then
		self:RegisterEvent("PLAYER_TALENT_UPDATE");
		self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
		self:SetScript("OnUpdate",TellMeWhen_OnUpdate)
		self.elapsed = 0;
		TellMeWhen_Update();
	elseif ( event == "PLAYER_TALENT_UPDATE") then
		TellMeWhen_Update();
	end
end

function TellMeWhen_OnUpdate(self,elapsed)
	self.elapsed = self.elapsed + elapsed
	if self.elapsed > 15 then
		for k,v in pairs(TMW.Warns) do
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000" .. L["ICON_TOOLTIP1"] .. " v" .. TELLMEWHEN_VERSION .. TELLMEWHEN_VERSION_MINOR .. ":|r ".. v)
		end
		self:SetScript("OnUpdate",nil)
		TMW.Warns = {}
		TMW.Warned = true
	end
end

function TellMeWhen_GetDefaults(group)
	local Defaults = CopyTable(TMW.Defaults)
	for groupID = 1, TELLMEWHEN_MAXGROUPS do
		Defaults["Groups"][groupID] = CopyTable({})
		for k,v in pairs(TMW.Group_Defaults) do
			if type(v) == "table" then
				Defaults["Groups"][groupID][k] = CopyTable(v)
			end
		end
		for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
			Defaults["Groups"][groupID].Icons[iconID] = {}
		end
		if group then return Defaults["Groups"][groupID] end
	end
	return Defaults
end

function TellMeWhen_VarsLoaded()
	SlashCmdList["TELLMEWHEN"] = TellMeWhen_SlashCommand;
	SLASH_TELLMEWHEN1 = "/tellmewhen";
	SLASH_TELLMEWHEN2 = "/tmw";
	if ( not TellMeWhen_Settings ) then
		TellMeWhen_Settings = TellMeWhen_GetDefaults()
		TellMeWhen_Settings.Groups[1]["Enabled"] = true;
	elseif ( TellMeWhen_Settings["Version"] < TELLMEWHEN_VERSION ) then
		TellMeWhen_SafeUpgrade();
	end
	TELLMEWHEN_MAXCONDITIONS = TellMeWhen_Settings["NumCondits"] or TELLMEWHEN_MAXCONDITIONS
	TELLMEWHEN_ICONSPACING = TellMeWhen_Settings["Spacing"] or TELLMEWHEN_ICONSPACING
	if LBF then
		LBF:RegisterSkinCallback("TellMeWhen", TellMeWhen_SkinCallback, self);
	end
	TellMeWhen_ConditionEditor_CreateGroups()
	TellMeWhen_Options_Compile()
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("TellMeWhen Options",L["ICON_TOOLTIP1"])
	LibStub("AceConfig-3.0"):RegisterOptionsTable("TellMeWhen Options", TMWoptionsTable)
end

function TellMeWhen_CondenseSettings(t)
	t=t or 1
	if t==1 then
		TellMeWhen_Settings_Safe = CopyTable(TellMeWhen_Settings)
	end
	for k,v in pairs(TellMeWhen_Settings.Groups) do
		if k > TELLMEWHEN_MAXGROUPS then TellMeWhen_Settings.Groups[k] = nil end
		if TellMeWhen_Settings.Groups[k] then
			for d,f in pairs(TellMeWhen_Settings.Groups[k]) do
				if f == TMW.Group_Defaults[d] then
					TellMeWhen_Settings.Groups[k][d] = nil
				end
			end
			for z,x in pairs(TellMeWhen_Settings.Groups[k].Icons) do
				local number = 0
				for a,s in pairs(TellMeWhen_Settings.Groups[k].Icons[z]) do
					number = number+1
					if TMW.Icon_DeletedSettings[a] or (s == TMW.Icon_Defaults[a]) or (a == "Conditions" and #s == 0) then
						TellMeWhen_Settings.Groups[k].Icons[z][a] = nil
					end
				end
				if ((number == 1) or (number == 2)) then
					local wipeit = true
					for o,p in pairs(TellMeWhen_Settings.Groups[k].Icons[z]) do
						if not ((o =="Enabled") or (o == "ShowTimerText")) then
							wipeit = false
						end
					end
					if wipeit then
						TellMeWhen_Settings.Groups[k].Icons[z] = {}
					end
				end
			end
		end
	end
	if t==1 then return TellMeWhen_CondenseSettings(2) end --NEEDS to be run twice in order to completely do everything, i dont have the patience to make it work with one run through
	TellMeWhen_Settings.Condensed = true
end

function TellMeWhen_SafeUpgrade()
	if (TellMeWhen_Settings.Version < "1.1.4") then
		TellMeWhen_Settings = TellMeWhen_GetDefaults()
		TellMeWhen_Settings.Groups[1]["Enabled"] = true;
		TellMeWhen_Settings.Version = TELLMEWHEN_VERSION;
	elseif (TellMeWhen_Settings.Version < "1.2.0") then
		TellMeWhen_Settings = TellMeWhen_AddNewSettings(TellMeWhen_Settings, TMW.Defaults);
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			if (groupID < 5) then
				TellMeWhen_Settings.Groups[groupID]["SecondarySpec"] = false;
			else
				local temp_groupID = groupID-4;
				TellMeWhen_Settings.Groups[groupID]["PrimarySpec"] = false;
			end
			if (oldgroupSettings) then
				TellMeWhen_Settings.Groups[groupID]["Enabled"] = oldgroupSettings.Enabled;
				TellMeWhen_Settings.Groups[groupID]["Scale"] = oldgroupSettings.Scale;
				TellMeWhen_Settings.Groups[groupID]["Rows"] = oldgroupSettings.Rows;
				TellMeWhen_Settings.Groups[groupID]["Columns"] = oldgroupSettings.Columns;
				TellMeWhen_Settings.Groups[groupID]["OnlyInCombat"] = oldgroupSettings.OnlyInCombat;
			end

			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if (oldgroupSettings) then
					oldiconSettings = oldgroupSettings["Icons"][iconID];
					if (oldiconSettings) then
						iconSettings = TellMeWhen_Settings.Groups[groupID].Icons[iconID];
						iconSettings.BuffOrDebuff = oldiconSettings.BuffOrDebuff;
						iconSettings.BuffShowWhen = oldiconSettings.BuffShowWhen;
						iconSettings.CooldownShowWhen = oldiconSettings.CooldownShowWhen;
						iconSettings.CooldownType = oldiconSettings.CooldownType;
						iconSettings.Enabled = oldiconSettings.Enabled;
						iconSettings.Name = oldiconSettings.Name;
						iconSettings.OnlyMine = oldiconSettings.OnlyMine;
						iconSettings.ShowTimer = oldiconSettings.ShowTimer;
						iconSettings.Type = oldiconSettings.Type;
						iconSettings.Unit = oldiconSettings.Unit;
						iconSettings.WpnEnchantType = oldiconSettings.WpnEnchantType;
					end
				end
				if (iconSettings.Name == "" and iconSettings.type ~= "wpnenchant") then
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Enabled"] = false;
				end
			end
		end
		TellMeWhen_Settings["Spec"] = nil;  -- Remove "Spec" {}
	end

	if (TellMeWhen_Settings.Version < "1.3.0") then
		TellMeWhen_Settings["Texture"] = "Interface\\TargetingFrame\\UI-StatusBar";
		TellMeWhen_Settings["TextureName"] = "Blizzard";
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["ShowPBar"] = false;
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["ShowCBar"] = false;
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["InvertBars"] = false;
			end
		end
	end
	if (TellMeWhen_Settings.Version < "1.4.0") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				iconSettings = TellMeWhen_Settings.Groups[groupID].Icons[iconID];
				if (iconSettings.Conditions == nil) then
					iconSettings.Conditions = {};
				end
				if (iconSettings.Alpha == nil) then
					iconSettings.Alpha = 1;
				end
			end
		end
	end
	if (TellMeWhen_Settings.Version < "1.4.1") then
		TellMeWhen_Settings.Interval = TELLMEWHEN_UPDATE_INTERVAL;
	end
	if (TellMeWhen_Settings.Version < "1.4.3") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			TellMeWhen_Settings.Groups[groupID]["Stance"] = {}
		end
	end
	if (TellMeWhen_Settings.Version < "1.4.4") then
		TellMeWhen_Settings["CDCOColor"] = {r=0,g=1,b=0,a=1}
		TellMeWhen_Settings["CDSTColor"] = {r=1,g=0,b=0,a=1}
	end
	if (TellMeWhen_Settings.Version < "1.4.5") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			TellMeWhen_Settings.Groups[groupID]["Point"] = {}
			local group = _G["TellMeWhen_Group"..groupID] or CreateFrame("Frame","TellMeWhen_Group"..groupID, UIParent, "TellMeWhen_GroupTemplate", groupID);
			local p = TellMeWhen_Settings.Groups[groupID]["Point"]
			p.point,_,p.relativePoint,p.x,p.y = group:GetPoint(1)
			TellMeWhen_Settings.Groups[groupID]["Point"] = p
		end
	end
	if (TellMeWhen_Settings.Version < "1.4.6") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["RangeCheck"] = false
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["ManaCheck"] = false
			end
		end
	end
	if (TellMeWhen_Settings.Version < "1.4.7") then
		TellMeWhen_Settings["DrawEdge"] = false
	end
	if (TellMeWhen_Settings.Version < "1.4.9.1") then
		TellMeWhen_Settings["OORColor"] = {r=0.5,g=0.5,b=0.5,a=1}
		TellMeWhen_Settings["OOMColor"] = {r=0.5,g=0.5,b=0.5,a=1}
	end
	if (TellMeWhen_Settings.Version < "1.5.3") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] > 1 then
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] = (TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] / 100)
				else
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] = 1
				end
				TellMeWhen_Settings.Groups[groupID].Icons[iconID]["UnAlpha"] = 1
			end
		end
	end
	if (TellMeWhen_Settings.Version < "1.5.4") then
		for groupID = 1, TELLMEWHEN_MAXOLDGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] == 0.01 then TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Alpha"] = 1 end
			end
		end
	end
	if (TellMeWhen_Settings.Version < "2.0.1") then
		TellMeWhen_Settings["USEColor"] 		= 	TellMeWhen_Settings["USEColor"]		or 	{r=1,g=1,b=1};
		TellMeWhen_Settings["UNUSEColor"] 	= 	TellMeWhen_Settings["UNUSEColor"]	or	{r=1,g=1,b=1};
		TellMeWhen_Settings["PRESENTColor"]	= 	TellMeWhen_Settings["PRESENTColor"]	or	{r=1,g=1,b=1};
		TellMeWhen_Settings["ABSENTColor"] 	= 	TellMeWhen_Settings["ABSENTColor"]	or	{r=1,g=0.35,b=0.35};
		local needtowarn = ""
		for groupID = TELLMEWHEN_MAXOLDGROUPS,TELLMEWHEN_MAXGROUPS do
			local group = _G["TellMeWhen_Group"..groupID] or CreateFrame("Frame","TellMeWhen_Group"..groupID, UIParent, "TellMeWhen_GroupTemplate",groupID);
			TellMeWhen_Settings.Groups[groupID] = TellMeWhen_Settings.Groups[groupID] or TellMeWhen_GetDefaults(true)
			TellMeWhen_Settings.Groups[groupID]["Enabled"] = TellMeWhen_Settings.Groups[groupID]["Enabled"] or false;
		end
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			TellMeWhen_Settings.Groups[groupID]["LBF"] = TellMeWhen_Settings.Groups[groupID]["LBF"] or {}
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] then
					for k,v in pairs(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) do
						v.ConditionLevel = tonumber(v.ConditionLevel) or 0
						if ((v.ConditionType == "SOUL_SHARDS") or (v.ConditionType == "HOLY_POWER")) and (v.ConditionLevel > 3) then
							needtowarn = needtowarn .. (format(L["GROUPICON"],groupID,iconID)) .. ";  "
							v.ConditionLevel = ceil((v.ConditionLevel/100)*3)
						end
					end
				end
			end
		end

		TellMeWhen_Settings["NumCondits"] = TELLMEWHEN_MAXCONDITIONS
		if needtowarn ~= "" then
			tinsert(TMW.Warns,L["HPSSWARN"] .. " " .. needtowarn)
		end
	end
	if (TellMeWhen_Settings.Version < "2.0.2.1") then
		local needtowarn = ""
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] then
					for k,v in pairs(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) do
						local isgood = false
						for z,x in pairs(TMW.IconMenu_SubMenus.Unit) do
							if v.ConditionUnit and v.ConditionUnit == x.value then
								isgood = true
							end
						end
						if not isgood then
							needtowarn = needtowarn .. (format(L["GROUPICON"],groupID,iconID)) .. ";  "
							v.Unit = "player"
						end
					end
				end
			end
		end
		if needtowarn ~= "" then
			tinsert(TMW.Warns,"The following icons have had the unit that their conditions check changed/fixed. You may wish to check them: " .. needtowarn)
		end
	end
	if (TellMeWhen_Settings.Version < "2.0.4") then
		TellMeWhen_Settings.Font = {
			["Path"] = "Fonts\\ARIALN.TTF",
			["Name"] = "Arial Narrow",
			["Size"] = 12,
			["Outline"] = "THICK"
		};
	end
	if (TellMeWhen_Settings.Version < "2.1.0") then
		if TellMeWhen_Settings.Font.Path == "FontsARIALN.TTF" then TellMeWhen_Settings.Font.Path = "Fonts\\ARIALN.TTF" end --i screwed something up and only put a single slash in at first that just acted as an escape so it dissapeared

		TellMeWhen_CondenseSettings()
		tinsert(TMW.Warns,"Your settings have had their size significantly reduced. If something is wrong, type '/tmw revert' to restore your old settings.")
	end
	if (TellMeWhen_Settings.Version < "2.1.2") then
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] == "thrown" then
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] = "RangedSlot"
				elseif TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] == "offhand" then
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] = "SecondaryHandSlot"
				elseif TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] == "mainhand" then --idk why this would happen, but you never know
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["WpnEnchantType"] = "MainHandSlot"
				end
			end
		end
	end
	if (TellMeWhen_Settings.Version < "2.2.0") then
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] then
					for k,v in pairs(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) do
						if ((v.ConditionType == "ICON") or (v.ConditionType == "EXISTS") or (v.ConditionType == "ALIVE")) then
							TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"][k]["ConditionLevel"] = 0
						end
					end
				end
			end
		end
	end
	if (TellMeWhen_Settings.Version < "2.2.0.1") then
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] then
					for i=1,#(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) do
						local temp = {}
						for k,v in pairs(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"][i]) do
							temp[gsub(k,"Condition","")] = v
						end
						TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"][i] = temp
					end
				end
			end
		end
	end
	if (TellMeWhen_Settings.Version < "2.2.1") then
		local number = 0
		for groupID = 1, TELLMEWHEN_MAXGROUPS do
			for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["UnitReact"] and TellMeWhen_Settings.Groups[groupID].Icons[iconID]["UnitReact"] ~= 0 then
					TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] = TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] or {}
					tinsert(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"],{
						["AndOr"] = "AND",
						["Type"] = "REACT",
						["Icon"] = "",
						["Operator"] = "==",
						["Level"] = TellMeWhen_Settings.Groups[groupID].Icons[iconID]["UnitReact"],
						["Unit"] = "target",
					})
				end
				if TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] and (#(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) > number) then
					number = #(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"])
				end
			end
		end
		if TellMeWhen_Settings["NumCondits"] < number then
			TellMeWhen_Settings["NumCondits"] = number
		end
		TellMeWhen_ConditionEditor_CreateGroups()
	end
	--All Upgrades Complete
	TellMeWhen_Settings["Version"] = TELLMEWHEN_VERSION;
end

function TMW_CondtFix()
	for groupID = 1, TELLMEWHEN_MAXGROUPS do
		for iconID = 1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
			TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] = TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"] or {}
			for k,v in pairs(TellMeWhen_Settings.Groups[groupID].Icons[iconID]["Conditions"]) do
				v.Level = tonumber(v.Level) or 0
			end
		end
	end
end

function TellMeWhen_AddNewSettings(settings, defaults)
	for k, v in pairs(defaults) do
		if ( not settings[k] ) then
			if ( type(v) == "table" ) then
				settings[k] = {};
				settings[k] = TellMeWhen_AddNewSettings(settings[k], defaults[k]);
			else
				settings[k] = v;
			end
		elseif ( type(v) == "table" ) then
			settings[k] = TellMeWhen_AddNewSettings(settings[k], defaults[k]);
		end
	end
	return settings;
end

function TellMeWhen_ColorUpdate()
	st = TellMeWhen_Settings.CDSTColor
	co = TellMeWhen_Settings.CDCOColor
	rc = TellMeWhen_Settings.OORColor
	mc = TellMeWhen_Settings.OOMColor
	us = TellMeWhen_Settings.USEColor
	un = TellMeWhen_Settings.UNUSEColor
	pr = TellMeWhen_Settings.PRESENTColor
	ab = TellMeWhen_Settings.ABSENTColor
end

function TellMeWhen_Update()
	TellMeWhen_ColorUpdate()
	TELLMEWHEN_UPDATE_INTERVAL = TellMeWhen_Settings.Interval or TELLMEWHEN_UPDATE_INTERVAL
	TELLMEWHEN_ICONSPACING = TellMeWhen_Settings["Spacing"] or TELLMEWHEN_ICONSPACING
	for groupID = 1, TELLMEWHEN_MAXGROUPS do
		TellMeWhen_Group_Update(groupID);
	end
	TellMeWhen_ConditionEditor_CreateGroups()
	TMW.Initd = true
	TellMeWhen_CopyPanel_Update()
end

do
	TMW.GCDSpells = {
		ROGUE=1752, -- sinister strike
		PRIEST=139, -- renew
		DRUID=774, -- rejuvenation
		WARRIOR=772, -- rend
		MAGE=133, -- fireball
		WARLOCK=687, -- demon armor
		PALADIN=20154, -- seal of righteousness
		SHAMAN=324, -- lightning shield
		HUNTER=1978, -- serpent sting
		DEATHKNIGHT=47541, -- death coil
	}

	GCDSpell = TMW.GCDSpells[pclass]
	chakra = {
		{abid = 88685, buffid = 81206}, 	-- sanctuary, prayer of healing,mending
		{abid = 88684, buffid = 81208},		-- serenity, heal
		{abid = 88682, buffid = 81207},		-- aspire, renew
	}

	--insert spells with Duplicate Spell Names here
	TMW.DSN = {};
	TMW.DSN[16511] = true;	-- hemo
	TMW.DSN[89775] = true;	-- glyph of hemo bleed
	TMW.DSN[19386] = true;	-- wyvern sting sleep
	TMW.DSN[24131] = true;	-- wyvern sting dot
	TMW.DSN[67016] = true;	-- flask of the north int
	TMW.DSN[67017] = true;	-- flask of the north agi
	TMW.DSN[67018] = true;	-- flask of the north str

	TMW.DS = {}; -- dispel types
	TMW.DS["Magic"] = true;
	TMW.DS["Curse"] = true;
	TMW.DS["Disease"] = true;
	TMW.DS["Poison"] = true;

	local ef = CreateFrame("Frame", "TellMeWhen_ExecutiveFrame");
	ef:SetScript("OnEvent", TellMeWhen_OnEvent);
	ef:RegisterEvent("ADDON_LOADED");
	ef:RegisterEvent("PLAYER_LOGIN");
	ef:RegisterEvent("PLAYER_ENTERING_WORLD");
end


-- -----------
-- GROUP FRAME
-- -----------

local function GetGroupSettings(group, groupID)
	for k,v in pairs(TMW.Group_Defaults) do
		if TellMeWhen_Settings.Groups[groupID][k] == nil then
			group[k] = TMW.Group_Defaults[k]
		else
			group[k] = TellMeWhen_Settings.Groups[groupID][k]
		end
	end
	return group
end

function TellMeWhen_GetGroupSetting(group,groupID,setting)
	if type(group) == "number" then --allow omission of group
		setting = groupID
		groupID = group
	end
	if type(group) == "table" and type(groupID) == "string" then --allow omission of groupID
		setting = groupID
		groupID = group:GetID()
	end
	if (not group) and (not groupID) then
		error("Not enough information to get a setting!")
	end
	if not setting then
		error("No setting specified to get")
	end
	if TellMeWhen_Settings.Groups[groupID][setting] == nil then
		return TMW.Group_Defaults[setting]
	else
		return TellMeWhen_Settings.Groups[groupID][setting]
	end
end

local function TellMeWhen_Stance_Check(group)
	if not group.correctspec then
		return
	end
	local groupID = group:GetID()
	local index = GetShapeshiftForm()

	if pclass == "WARLOCK" and index == 2 then  --UGLY HACK FOR METAMORPHOSIS, IT IS INDEX 2 FOR SOME REASON
		index = 1
	end
	if pclass == "ROGUE" and index >= 2 then	--UGLY FIX FOR ROGUES, VANISH AND SHADOW DANCE RETURN 3 WHEN ACTIVE, VANISH RETURNS 2 WHEN SHADOW DANCE ISNT LEARNED.
		index = 1
	end
	if index > GetNumShapeshiftForms() then --MANY CLASSES RETURN AN INVALID NUMBER ON LOGIN, BUT NOT ANYMORE!
		index = 0
	end
	if index == 0 then
		if not TellMeWhen_Settings.Groups[groupID]["Stance"][0] then
			if group.combatcheck then
				if UnitAffectingCombat("player") then
					group:Show();
				elseif not UnitAffectingCombat("player") then
					group:Hide();
				end
			else
				group:Show()
			end
		else
			group:Hide();
		end
	elseif index ~= nil then
		local texture, name, isActive, isCastable = GetShapeshiftFormInfo(index)
		if not name then error("Uh oh! Something happened to the stance checks! Please send this error in Cybeloras' direction, as well as what you were doing at the time:" .. index .. ":" .. pclass .. ":") return end
		local _,_,ID = strfind(GetSpellLink(name), ":(%d+)")
		for k,v in pairs(TMW.CS) do
			if TMW.CS[k] == tonumber(ID) then
				if not TellMeWhen_Settings.Groups[groupID]["Stance"][k] then
					if group.combatcheck then
						if UnitAffectingCombat("player") then
							group:Show();
						elseif not UnitAffectingCombat("player") then
							group:Hide();
						end
					else
						group:Show()
					end
				else
					group:Hide();
				end
			end
		end
	end
end

function TellMeWhen_Group_OnEvent(self, event,...)
	if (event == "PLAYER_REGEN_ENABLED" or event == "PLAYER_REGEN_DISABLED") then
		if self.combatcheck then
			if UnitAffectingCombat("player") then
				self:Show();
			elseif not UnitAffectingCombat("player") then
				self:Hide();
			end
		end
	elseif (event == "UPDATE_SHAPESHIFT_FORM" or event == "UPDATE_SHAPESHIFT_FORMS") then
		TellMeWhen_Stance_Check(self)
	end
end

function TellMeWhen_Group_Update(groupID)
	local group = _G["TellMeWhen_Group"..groupID] or CreateFrame("Frame","TellMeWhen_Group"..groupID, UIParent, "TellMeWhen_GroupTemplate",groupID);
	TellMeWhen_Settings.Groups = TellMeWhen_Settings.Groups or {}
	TellMeWhen_Settings.Groups[groupID] = TellMeWhen_Settings.Groups[groupID] or TellMeWhen_GetDefaults(true)
	group.groupName = "TellMeWhen_Group"..groupID;
	group.resizeButton = _G[group.groupName.."_ResizeButton"];
	group = GetGroupSettings(group, groupID)
	local locked = TellMeWhen_Settings["Locked"];

	local currentSpec = GetActiveTalentGroup();
	group.correctspec = true

	if not group.Enabled then
		for row = 1, group.Rows do
			for column = 1, group.Columns do
				local iconID = (row-1)*group.Columns + column;
				local iconName = group.groupName.."_Icon"..iconID;
				for k,v in pairs(TMW.Icons) do
					if TMW.Icons[k] == iconName then
						TMW.Icons[k] = nil
					end
				end
			end
		end
	end
	if (currentSpec==1 and not group.PrimarySpec) or (currentSpec==2 and not group.SecondarySpec) then
		group.Enabled = false;
		group.correctspec = false
	end
	if LBF then
		TMW.DontRun = true
		local lbfs = TellMeWhen_Settings.Groups[groupID]["LBF"]
		LBF:Group("TellMeWhen", L["GROUP"] .. groupID)
		if lbfs.SkinID then
			LBF:Group("TellMeWhen", L["GROUP"] .. groupID):Skin(lbfs.SkinID,lbfs.Gloss,lbfs.Backdrop,lbfs.Colors)
		end
	end
	if (group.Enabled) then
		for row = 1, group.Rows do
			for column = 1, group.Columns do
				local iconID = (row-1)*group.Columns + column;
				local iconName = group.groupName.."_Icon"..iconID;
				local icon = _G[iconName] or CreateFrame("Button", iconName, group, "TellMeWhen_IconTemplate",iconID);
				local powerbarname = iconName.."_PowerBar";
				local cooldownbarname = iconName.."_CooldownBar";
				icon.powerbar = icon.powerbar or CreateFrame("StatusBar",powerbarname,icon)
				icon.cooldownbar = icon.cooldownbar or CreateFrame("StatusBar",cooldownbarname,icon)
				icon:Show();
				if ( column > 1 ) then
					icon:SetPoint("TOPLEFT", _G[group.groupName.."_Icon"..(iconID-1)], "TOPRIGHT", TELLMEWHEN_ICONSPACING, 0);
				elseif ( row > 1 ) and ( column == 1 ) then
					icon:SetPoint("TOPLEFT", _G[group.groupName.."_Icon"..(iconID-group.Columns)], "BOTTOMLEFT", 0, -TELLMEWHEN_ICONSPACING);
				elseif ( iconID == 1 ) then
					icon:SetPoint("TOPLEFT", group, "TOPLEFT");
				end
				TellMeWhen_Icon_Update(icon, groupID, iconID);
			end
		end
		for iconID = group.Rows*group.Columns+1, TELLMEWHEN_MAXROWS*TELLMEWHEN_MAXROWS do
			local icon = _G[group.groupName.."_Icon"..iconID];
			if icon then
				icon:Hide();
				TellMeWhen_Icon_ClearScripts(icon);
			end
		end

		group:SetScale(group.Scale);
		local lastIcon = group.groupName.."_Icon"..(group.Rows*group.Columns);
		group.resizeButton:SetPoint("BOTTOMRIGHT", lastIcon, "BOTTOMRIGHT", 3, -3);
		if ( locked ) then
			group.resizeButton:Hide();
		else
			group.resizeButton:Show();
		end

		TellMeWhen_Stance_Check(group)
	end
	TellMeWhen_SetGroupPositions(group,groupID)

	if ( group.OnlyInCombat and group.Enabled and locked ) then
		group:RegisterEvent("PLAYER_REGEN_ENABLED");
		group:RegisterEvent("PLAYER_REGEN_DISABLED");
		group:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
		group:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
		group.combatcheck = true
		group:Hide();
	elseif (group.Enabled and locked) then
		group:RegisterEvent("UPDATE_SHAPESHIFT_FORM");
		group:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
		group.combatcheck = false
		group:Show();
	else
		group:UnregisterAllEvents();
		group.combatcheck = false
		if ( group.Enabled ) then
			group:Show();
		else
			group:Hide();
		end
	end

	group:SetScript("OnEvent", TellMeWhen_Group_OnEvent)
end


-- -------------
-- ICON FUNCTIONS
-- -------------

local function GetIconSettings(icon, groupID, iconID)
	for k,v in pairs(TMW.Icon_Defaults) do
		if TellMeWhen_Settings.Groups[groupID].Icons[iconID] == nil or TellMeWhen_Settings.Groups[groupID].Icons[iconID][k] == nil then
			icon[k] = TMW.Icon_Defaults[k]
		else
			icon[k] = TellMeWhen_Settings.Groups[groupID].Icons[iconID][k]
		end
	end
	return icon
end

function TellMeWhen_GetIconSetting(icon,groupID,iconID,setting)
	if type(icon) == "number" then --allow omission of icon
		setting = iconID
		iconID = groupID
		groupID = icon
	end
	if type(icon) == "table" and type(groupID) == "string" then --allow omission of group and icon IDs
		setting = groupID
		iconID = icon:GetID()
		groupID = icon:GetParent():GetID()
	end
	if (not setting) or ((not icon) and (not (groupID and iconID))) then
		return
	end
	if TellMeWhen_Settings.Groups[groupID].Icons[iconID] == nil or TellMeWhen_Settings.Groups[groupID].Icons[iconID][setting] == nil then
		return TMW.Icon_Defaults[setting]
	else
		return TellMeWhen_Settings.Groups[groupID].Icons[iconID][setting]
	end
end

function TellMeWhen_Icon_Update(icon, groupID, iconID)
	icon					= GetIconSettings(icon, groupID, iconID)
	icon.IsChakra			= false;
	icon.ChakraActive 		= true;
	icon.Width				= icon.Width or 36
	icon.Height				= icon.Height or 36
	icon.updateTimer 		= TELLMEWHEN_UPDATE_INTERVAL;

	icon.texture = _G[icon:GetName().."Icon"];
	icon.countText = _G[icon:GetName().."Count"];
	icon.Cooldown = _G[icon:GetName().."Cooldown"];
	icon.Cooldown.noCooldownCount = not icon.ShowTimerText
	icon.Cooldown:SetFrameLevel(icon:GetFrameLevel() + 1)
	icon.Cooldown:SetDrawEdge(TellMeWhen_Settings["DrawEdge"])

	icon.countText:SetFont(TellMeWhen_Settings.Font.Path,TellMeWhen_Settings.Font.Size,TellMeWhen_Settings.Font.Outline)
	--LBF STUFF
	if LBF then
		TMW.DontRun = true -- TellMeWhen_Update() is ran in the LBF skin callback, which just causes an infinite loop. This tells it not to
		local lbfs = TellMeWhen_Settings.Groups[groupID]["LBF"]
		LBF:Group("TellMeWhen", L["GROUP"] .. groupID):AddButton(icon);
		local SkID = lbfs.SkinID or "Blizzard"
		local tab = LBF:GetSkins()
		if tab and SkID then
			if SkID == "Blizzard" then --blizzard needs custom overlay bar sizes because of the borders, other skins might like to use this too
				icon.Width = (tab[SkID].Icon.Width)*0.9
				icon.Height = (tab[SkID].Icon.Height)*0.9
			else
				icon.Width = tab[SkID].Icon.Width
				icon.Height = tab[SkID].Icon.Height
			end
		end
		icon.countText:SetFont(TellMeWhen_Settings.Font.Path,tab[SkID].Count.FontSize or TellMeWhen_Settings.Font.Size,TellMeWhen_Settings.Font.Outline)
	else
		icon.Width = 36*0.9
		icon.Height = 36*0.9
	end

	icon:UnregisterAllEvents();
	icon.countText:Hide();

	icon.conditionPresent = false
	if (icon.Conditions and #(icon.Conditions) > 0) then
		icon.conditionPresent = true;
	end

	TellMeWhen_Icon_ClearScripts(icon);
	if icon.Enabled and TellMeWhen_GetGroupSetting(groupID,"Enabled") then
		local isin = false
		for k,v in pairs(TMW.Icons) do
			if TMW.Icons[k] == icon:GetName() then
				isin = true
			end
		end
		if not isin then
			tinsert(TMW.Icons,icon:GetName())
		end
	else
		for k,v in pairs(TMW.Icons) do
			if TMW.Icons[k] == icon:GetName() then
				TMW.Icons[k] = nil
			end
		end
	end

	if not ( TellMeWhen_Settings["Locked"] and not icon.Enabled) then
		-- used by both cooldown and reactive icons
		if ( icon.CooldownShowWhen == "usable" ) then
			icon.usableAlpha = (1 * icon.Alpha);
			icon.unusableAlpha = (0 * icon.UnAlpha);
		elseif ( icon.CooldownShowWhen == "unusable" ) then
			icon.usableAlpha = (0 * icon.Alpha); --hey, you never know, multiplying by zero might become useful in the future
			icon.unusableAlpha = (1 * icon.UnAlpha);
		elseif ( icon.CooldownShowWhen == "always") then
			icon.usableAlpha = (1 * icon.Alpha);
			icon.unusableAlpha = (1 * icon.UnAlpha);
		else
			error("Alpha not assigned: "..icon.Name);
			icon.usableAlpha = (1 * icon.Alpha);
			icon.unusableAlpha = (1 * icon.UnAlpha);
		end
		-- used by both buff/debuff and wpnenchant icons
		if ( icon.BuffShowWhen == "present" ) then
			icon.presentAlpha = (1 * icon.Alpha);
			icon.absentAlpha = (0 * icon.UnAlpha);
		elseif ( icon.BuffShowWhen == "absent" ) then
			icon.presentAlpha = (0 * icon.Alpha);
			icon.absentAlpha = (1 * icon.UnAlpha);
		elseif ( icon.BuffShowWhen == "always") then
			icon.presentAlpha = (1 * icon.Alpha);
			icon.absentAlpha = (1 * icon.UnAlpha);
		else
			error("Alpha not assigned: "..icon.Name);
			icon.presentAlpha = (1 * icon.Alpha);
			icon.absentAlpha = (1 * icon.UnAlpha);
		end


		if ( icon.Type == "cooldown" ) then
-- --------------
-- SPELL COOLDOWN
-- --------------
			if ( icon.CooldownType == "spell" ) then
				icon.namefirst = TellMeWhen_GetSpellNames(icon,icon.Name,1)
				icon.namename = TellMeWhen_GetSpellNames(icon,icon.Name,1,true)

				icon.texture:SetTexture(GetSpellTexture(icon.namefirst) or "Interface\\Icons\\INV_Misc_QuestionMark");
				icon:SetScript("OnUpdate", TellMeWhen_Icon_SpellCooldown_OnUpdate);
				TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
				icon:RegisterEvent("SPELL_UPDATE_USABLE");
				icon:RegisterEvent("SPELL_UPDATE_COOLDOWN");
				icon:SetScript("OnEvent", TellMeWhen_Icon_SpellCooldown_OnEvent);
				TellMeWhen_Icon_StatusCheck(icon);
				
-- --------------
-- ITEM COOLDOWN
-- --------------
			elseif ( icon.CooldownType == "item" ) then
				icon.namefirst = TellMeWhen_GetItemIDs(icon,icon.Name,1)
				if icon.Slot <= 19 then
					icon.namefirst = icon.namefirst or 0
					icon:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
				end
				icon.ShowPBar = false;
				icon.powerbar:Hide();
				TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
				local itemName, itemLink, _, _, _, _, _, _, _, itemTexture = GetItemInfo(icon.namefirst)
				icon:SetScript("OnUpdate", TellMeWhen_Icon_ItemCooldown_OnUpdate)
				if ( itemName ) then
					icon.texture:SetTexture(itemTexture);
					if icon.ShowTimer then
						icon:RegisterEvent("BAG_UPDATE_COOLDOWN");
					end
				else
					TellMeWhen_Icon_ClearScripts(icon);
					icon.learnedTexture = false;
					icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
				end
				icon:SetScript("OnEvent", TellMeWhen_Icon_ItemCooldown_OnEvent);
			end
			icon.Cooldown:SetReverse(false);
			TellMeWhen_Icon_StatusCheck(icon);
-- --------------
-- BUFF
-- --------------
		elseif ( icon.Type == "buff" ) then
			icon.namefirst = TellMeWhen_GetSpellNames(icon,icon.Name,1)
			icon.namename = TellMeWhen_GetSpellNames(icon,icon.Name,1,1)
			icon.namelist = TellMeWhen_GetSpellNames(icon,icon.Name)
			icon.namenamelist = TellMeWhen_GetSpellNames(icon,icon.Name,nil,1)

			icon.filter = icon.BuffOrDebuff;
			icon.filterh = ((icon.BuffOrDebuff == "EITHER") and "HARMFUL");
			if icon.OnlyMine then
				icon.filter = icon.filter.."|PLAYER"
				if icon.filterh then icon.filterh = icon.filterh.."|PLAYER" end
			end

			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
			icon:SetScript("OnUpdate",TellMeWhen_Icon_Buff_OnUpdate)
			icon.countText:Show()
			if (icon.StackMin ~= TMW.Icon_Defaults.StackMin) and (icon.StackMax ~= TMW.Icon_Defaults.StackMax) then
				icon.Stacks = true
			else
				icon.Stacks = false
			end
			if ( icon.Name == "" ) then
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
			elseif ( GetSpellTexture(icon.namefirst) ) then
				icon.texture:SetTexture(GetSpellTexture(icon.namefirst));
			elseif ( not icon.learnedTexture ) then
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_PocketWatch_01");
			end
			icon.Cooldown:SetReverse(true);
			TellMeWhen_Icon_StatusCheck(icon);
-- --------------
-- REACTIVE
-- --------------
		elseif ( icon.Type == "reactive" ) then
			icon.namefirst = TellMeWhen_GetSpellNames(icon,icon.Name,1)
			icon.namename = TellMeWhen_GetSpellNames(icon,icon.Name,1,true)

			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
			if ( GetSpellTexture(icon.namefirst) ) then
				icon.texture:SetTexture(GetSpellTexture(icon.namefirst));
				icon:SetScript("OnUpdate", TellMeWhen_Icon_Reactive_OnUpdate);
			else
				TellMeWhen_Icon_ClearScripts(icon);
				icon.learnedTexture = false;
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
			end
		--	icon:RegisterEvent("PET_BAR_UPDATE");
			icon:RegisterEvent("SPELL_UPDATE_USABLE");
			icon:RegisterEvent("SPELL_UPDATE_COOLDOWN");
			icon:SetScript("OnEvent", TellMeWhen_Icon_SpellCooldown_OnEvent);
			TellMeWhen_Icon_StatusCheck(icon);


-- --------------
-- WEP ENCHANT
-- --------------
		elseif ( icon.Type == "wpnenchant" ) then
			icon.namefirst = TellMeWhen_GetSpellNames(icon,icon.Name,1)

			icon.ShowPBar = false;
			icon.ShowCBar = false;
			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
			icon:RegisterEvent("UNIT_INVENTORY_CHANGED");
			local slotID = GetInventorySlotInfo(icon.WpnEnchantType);
			icon.countText:Show()
			local wpnTexture = GetInventoryItemTexture("player", slotID);
			if ( wpnTexture ) then
				icon.texture:SetTexture(wpnTexture);
				icon:SetScript("OnEvent", TellMeWhen_Icon_WpnEnchant_OnEvent);
				icon:SetScript("OnUpdate", TellMeWhen_Icon_WpnEnchant_OnUpdate);
			else
				TellMeWhen_Icon_ClearScripts(icon);
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
			end

-- --------------
-- TOTEM
-- --------------
		elseif ( icon.Type == "totem" ) then
			icon.namefirst = TellMeWhen_GetSpellNames(icon,icon.Name,1)
			icon.namename = TellMeWhen_GetSpellNames(icon,icon.Name,1,1)
			icon.namelist = TellMeWhen_GetSpellNames(icon,icon.Name)

			icon.ShowPBar = false;
			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)


			icon:SetScript("OnUpdate", TellMeWhen_Icon_Totem_OnUpdate);
			TellMeWhen_Icon_Totem_OnUpdate(icon);
			if ( icon.Name == "" ) then
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
				icon.learnedTexture = false;
			elseif ( GetSpellTexture(icon.namefirst) ) then
				icon.texture:SetTexture(GetSpellTexture(icon.namefirst));
			elseif ( not icon.learnedTexture ) then
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_PocketWatch_01");
			end
			
-- --------------
-- DARK SIM
-- --------------
		elseif ( icon.Type == "darksim" ) then
			icon.Slot = 0
			for i=1,120 do
				local type, spellID = GetActionInfo(i)
				if spellID == 77606 then
					icon.Slot = i
				end
			end
			icon.texture:SetTexture(GetActionTexture(icon.Slot) or "Interface\\Icons\\INV_Misc_QuestionMark");
			icon:SetScript("OnUpdate", TellMeWhen_Icon_DarkSim_OnUpdate);
			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
			icon:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
			icon:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
			icon:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
			icon:SetScript("OnEvent", TellMeWhen_Icon_DarkSim_OnEvent);
			TellMeWhen_Icon_StatusCheck(icon);
			
		else
			icon.ShowPBar = false;
			icon.ShowCBar = false;
			TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
			TellMeWhen_Icon_ClearScripts(icon);
			if ( icon.Name ~= "" ) then
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
			else
				icon.texture:SetTexture(nil);
			end
		end
	end -- icon.Enabled CHECK

	icon.Cooldown:Hide();
	if ( icon.Enabled ) then
		icon:SetAlpha(1.0);
	else
		icon:SetAlpha(0.4);
		TellMeWhen_Icon_ClearScripts(icon);
	end

	icon:Show();
	if ( TellMeWhen_Settings["Locked"] ) then
		icon:DisableDrawLayer("BACKGROUND")
		icon:EnableMouse(0);
		if ( not icon.Enabled ) then
			icon:Hide();
			icon.powerbar:Hide();
			icon.cooldownbar:Hide();
		elseif (icon.Name == "") and ( icon.Type ~= "wpnenchant" ) then
			icon:Hide();
		end
		icon.powerbar:SetValue(0);
		icon.cooldownbar:SetValue(0);
		icon.powerbar:SetAlpha(.9)


	else
		if ( not icon.texture:GetTexture() ) then
			icon:EnableDrawLayer("BACKGROUND")
		else
			icon:DisableDrawLayer("BACKGROUND")
		end
		if not icon.cooldownbar.texture then
			icon.cooldownbar.texture = icon.cooldownbar:CreateTexture()
		end
		if not icon.powerbar.texture then
			icon.powerbar.texture = icon.powerbar:CreateTexture()
		end
		icon.cooldownbar:SetMinMaxValues(0,  1)
		icon.cooldownbar:SetValue(2000000)
		icon.cooldownbar:SetStatusBarColor(0, 1, 0, 0.5)
		icon.cooldownbar.texture:SetTexCoord(0, 1, 0, 1)
		icon.powerbar:SetValue(2000000)
		icon.powerbar:SetAlpha(.5)
		icon.powerbar.texture:SetTexCoord(0, 1, 0, 1)
		icon:EnableMouse(1);
		icon.texture:SetVertexColor(1, 1, 1, 1);
		TellMeWhen_Icon_ClearScripts(icon);
	end
end

function TellMeWhen_Icon_Bars_Update(icon, groupID, iconID)
	if icon.ShowPBar or icon.ShowCBar then
		local groupName = "TellMeWhen_Group"..groupID;
		local iconName = groupName.."_Icon"..iconID;
		local Enabled = icon.Enabled
		local locked = TellMeWhen_Settings["Locked"];
		local OnlyInCombat = icon:GetParent().OnlyInCombat
		local width, height = icon:GetSize()
		local scale = icon:GetParent().Scale
		if not TellMeWhen_Settings["Texture"] then
			TellMeWhen_Settings["Texture"] = "Interface\\TargetingFrame\\UI-StatusBar";
		end
		if not TellMeWhen_Settings["TextureName"] then
			TellMeWhen_Settings["TextureName"] = "Blizzard";
		end
		local tex = TellMeWhen_Settings["Texture"]
		if icon.ShowPBar then
			local _,_,_,cost,_,powerType = GetSpellInfo(icon.namefirst);
			if cost == nil then cost = 0 end
			local powerbarname = iconName.."_PowerBar";
			if not icon.powerbar then
				icon.powerbar = CreateFrame("StatusBar",powerbarname,icon)
			end
			icon.powerbar:SetSize(width*(icon.Width/36), ((height / 2)*(icon.Height/36))-0.5);
			icon.powerbar:SetPoint("BOTTOM",icon,"CENTER",0,0.5)--(((height/2)*(icon.Height/36))-(icon.cooldownbar:GetHeight() )));
			if cost then
				icon.powerbar:SetMinMaxValues(0, cost);
			end
			if not icon.powerbar.texture then
				icon.powerbar.texture = icon.powerbar:CreateTexture()
			end
			icon.powerbar.texture:SetTexture(tex);
			if powerType then
				local colorinfo = PowerBarColor[powerType];
				icon.powerbar.texture:SetVertexColor(colorinfo.r, colorinfo.g, colorinfo.b, 0.9);
			end
			icon.powerbar:SetStatusBarTexture(icon.powerbar.texture);
			icon.powerbar:SetFrameLevel(icon:GetFrameLevel() + 2);
		end
		if icon.ShowCBar then
			local cooldownbarname = iconName.."_CooldownBar";
			icon.cooldownbar = icon.cooldownbar or CreateFrame("StatusBar",cooldownbarname,icon);
			icon.cooldownbar:SetSize(width*(icon.Width/36), ((height / 2)*(icon.Height/36))-0.5);
			icon.cooldownbar:SetPoint("TOP",icon,"CENTER",0,-0.5)---(((height/2)*(icon.Height/36))-(icon.cooldownbar:GetHeight() )));
			icon.cooldownbar.texture = icon.cooldownbar.texture or icon.cooldownbar:CreateTexture();
			icon.cooldownbar.texture:SetTexture(tex);
			icon.cooldownbar:SetStatusBarTexture(icon.cooldownbar.texture);
			icon.cooldownbar:SetFrameLevel(icon:GetFrameLevel() + 2);
			icon.cooldownbar:SetMinMaxValues(0,  1)
		end
	end
	if not icon.ShowPBar then
		icon.powerbar:Hide();
	else
		icon.powerbar:Show()
	end
	if not icon.ShowCBar then
		icon.cooldownbar:Hide();
	else
		icon.cooldownbar:Show()
	end
end

function TellMeWhen_Icon_ClearScripts(icon)
	icon:SetScript("OnEvent", nil);
	icon:SetScript("OnUpdate", nil);
end

function TellMeWhen_Icon_StatusCheck(icon)
	-- this function is so icons can do a check when the addon is locked
	-- the 1s trick it into thinking that it has been a long time since the last onupdate and so it will run the whole function.
	if ( icon.Type == "reactive" ) then
		TellMeWhen_Icon_Reactive_OnUpdate(icon,1)
	elseif ( icon.Type == "buff" ) then
		TellMeWhen_Icon_Buff_OnUpdate(icon,1);
	elseif ( icon.Type == "cooldown" ) then
		if (icon.CooldownType == "spell") then
			TellMeWhen_Icon_SpellCooldown_OnUpdate(icon,1);
			TellMeWhen_Icon_SpellCooldown_OnEvent(icon)
		elseif (icon.CooldownType == "item") then
			TellMeWhen_Icon_ItemCooldown_OnUpdate(icon,1);
			TellMeWhen_Icon_ItemCooldown_OnEvent(icon)
		end
	elseif (icon.Type == "wpnenchant") then
		TellMeWhen_Icon_WpnEnchant_OnEvent(icon,thisdoesntmatter,"player")
	elseif icon.Type == "darksim" then 
		TellMeWhen_Icon_DarkSim_OnUpdate(icon,1);
		TellMeWhen_Icon_DarkSim_OnEvent(icon)
	end
end

local function GetGCD()
	local _,ret=GetSpellCooldown(GCDSpell)
	if ret > 1.7 then return 0 end
	return ret
end

local function ConditionCheck(Conditions)
	local retCode = TMW_CNDT[Conditions[1].Type](Conditions[1]);
	for i=2,#Conditions do
		retCode = TMW_AO[Conditions[i].AndOr](retCode,TMW_CNDT[Conditions[i].Type](Conditions[i]))
	end
	return retCode;
end

local function CDBarUpdate(icon,startTime,duration,buff)
	local bar = icon.cooldownbar
	local percentcomplete = 1
	local OnGCD = GetGCD() == duration and duration > 0;
	if OnGCD and not buff and not TellMeWhen_Settings["BarGCD"] then
		duration = 0
	end
	if not icon.InvertBars then
		if (duration == 0) then
			bar:SetMinMaxValues(0,  1)
			bar:SetValue(0)
		else
			percentcomplete = ((GetTime() - startTime) / duration)
			bar:SetMinMaxValues(0,  duration)
			bar:SetValue(duration - (GetTime() - startTime))
			bar.texture:SetTexCoord(0, min((1-percentcomplete),1), 0, 1)
			bar:SetStatusBarColor(
				(co.r*percentcomplete) + (st.r * (1-percentcomplete)),
				(co.g*percentcomplete) + (st.g * (1-percentcomplete)),
				(co.b*percentcomplete) + (st.b * (1-percentcomplete)),
				(co.a*percentcomplete) + (st.a * (1-percentcomplete))
			)
		end
	else
		--inverted
		if (duration == 0) then
			bar:SetMinMaxValues(0,1)
			bar:SetValue(1)
			bar:SetStatusBarColor(co.r, co.g, co.b, co.a)
			bar.texture:SetTexCoord(0, 1, 0, 1)
		else
			percentcomplete = (((GetTime() - startTime) / duration))
			bar:SetMinMaxValues(0,  duration)
			bar:SetValue(GetTime() - startTime)
			bar.texture:SetTexCoord(0, min(percentcomplete,1), 0, 1)
			bar:SetStatusBarColor(
				(co.r*percentcomplete) + (st.r * (1-percentcomplete)),
				(co.g*percentcomplete) + (st.g * (1-percentcomplete)),
				(co.b*percentcomplete) + (st.b * (1-percentcomplete)),
				(co.a*percentcomplete) + (st.a * (1-percentcomplete))
			)
		end
	end
end

local function PwrBarUpdate(icon,name)
	local bar = icon.powerbar
	local _,_,_,cost,_,powerType = GetSpellInfo(name)
	cost = cost or 0
	bar:SetMinMaxValues(0, cost);
	if not icon.InvertBars then
		bar:SetValue(cost - UnitPower("player",powerType))
		bar.texture:SetTexCoord(0, max(0,((cost - UnitPower("player",powerType)) / cost)), 0, 1)
	else
		bar:SetValue(UnitPower("player",powerType))
		bar.texture:SetTexCoord(0, max(0,(UnitPower("player",powerType) / cost)), 0, 1)
	end
end


-- -------------
-- ICON SCRIPTS
-- -------------

function TellMeWhen_Icon_SpellCooldown_OnEvent(icon)
	local startTime, duration = GetSpellCooldown(icon.namefirst);
	if (not icon.ShowTimer) or ((not TellMeWhen_Settings["ClockGCD"]) and (GetGCD() == duration and duration > 0)) then return end
	if ( duration ) then
		CooldownFrame_SetTimer(icon.Cooldown, startTime, duration, 1);
	end
end

function TellMeWhen_Icon_SpellCooldown_OnUpdate(icon, elapsed)
	icon.updateTimer = icon.updateTimer - elapsed;
	local name = icon.namefirst
	local namename = icon.namename
	local startTime, duration = GetSpellCooldown(name);
	if duration and namename then
		if icon.ShowPBar then
			PwrBarUpdate(icon,name)
		end
		if icon.ShowCBar then
			CDBarUpdate(icon,startTime,duration)
		end
		if ( icon.updateTimer <= 0 ) then
			icon.updateTimer = TELLMEWHEN_UPDATE_INTERVAL;
			if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
				icon:SetAlpha(icon.ConditionAlpha);
				icon.CondtShown = 0
				return;
			end
			if icon.IsChakra then
				if UnitAura("player",GetSpellInfo(chakra[icon.IsChakra]["buffid"])) then
					icon.ChakraActive = true
				else
					icon.ChakraActive = false
				end
			end
			local inrange = IsSpellInRange(namename, "target");
			local _, nomana = IsUsableSpell(name);
			local OnGCD = GetGCD() == duration and duration > 0;
			local _,_,_,_,_,_,_,minRange,maxRange = GetSpellInfo(name);
			if ( not icon.RangeCheck or not maxRange or inrange == nil ) then
				inrange = 1;
			end
			if not icon.ManaCheck then
				nomana = nil
			end

			if ( (duration == 0 or OnGCD) and inrange == 1 and not nomana and icon.ChakraActive) then
				icon.texture:SetVertexColor(1, 1, 1, 1);
				icon:SetAlpha(icon.usableAlpha);
			elseif ( icon.usableAlpha ~= 0 and icon.ChakraActive) then
				if inrange ~= 1 then
					icon.texture:SetVertexColor(rc.r, rc.g, rc.b, 1);
					icon:SetAlpha(icon.unusableAlpha*rc.a);
				elseif nomana then
					icon.texture:SetVertexColor(mc.r, mc.g, mc.b, 1);
					icon:SetAlpha(icon.unusableAlpha*mc.a);
				elseif not icon.ShowTimer then
					icon.texture:SetVertexColor(0.5, 0.5, 0.5, 1);
					icon:SetAlpha(icon.unusableAlpha);
				else
					icon.texture:SetVertexColor(1, 1, 1, 1);
					icon:SetAlpha(icon.unusableAlpha);
				end
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
				icon:SetAlpha(icon.unusableAlpha);
			end
			icon.CondtShown = icon:GetAlpha()
			if icon.FakeHidden then
				icon:SetAlpha(0)
			end
		end
	elseif (not namename) and icon:GetScript("OnEvent") and duration then
		TellMeWhen_Icon_ClearScripts(icon);
		if TMW.Warned then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000" .. L["ICON_TOOLTIP1"] .. " v" .. TELLMEWHEN_VERSION .. TELLMEWHEN_VERSION_MINOR .. ":|r ".. icon:GetName() .. " disabled to prevent massive error spam. Type /tmw and change the name of the icon to a spellID to fix this.")
		else
			TMW.Warns[tonumber(icon:GetID() .. icon:GetParent():GetID())] = icon:GetName() .. " disabled to prevent massive error spam. Type /tmw and change the name of the icon to a spellID to fix this."
		end
	end
end

function TellMeWhen_Icon_ItemCooldown_OnEvent(icon,event,...)
	if event == "PLAYER_EQUIPMENT_CHANGED" then
		local slot, has = ...
		if (icon.Slot == slot) and has then
			icon.namefirst = TellMeWhen_GetItemIDs(icon,icon.Name,1)
			local itemName, itemLink, _, _, _, _, _, _, _, itemTexture = GetItemInfo(icon.namefirst)
			if ( itemName ) then
				icon.texture:SetTexture(itemTexture);
				if icon.ShowTimer then
					icon:RegisterEvent("BAG_UPDATE_COOLDOWN");
				end
			else
				icon.learnedTexture = false;
				icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
			end
		elseif (icon.Slot == slot) then
			icon.namefirst = 0
			icon.learnedTexture = false;
			icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
		end
		return
	end
	local startTime, duration = GetItemCooldown(icon.namefirst);
	if (not TellMeWhen_Settings["ClockGCD"]) and (GetGCD() == duration and duration > 0) then return end
	if ( duration ) then
		CooldownFrame_SetTimer(icon.Cooldown, startTime, duration, 1);
	end
end

function TellMeWhen_Icon_ItemCooldown_OnUpdate(icon, elapsed)
	icon.updateTimer = icon.updateTimer - elapsed;
	local namefirst = icon.namefirst
	local startTime, duration = GetItemCooldown(namefirst);
	if icon.ShowCBar then
		CDBarUpdate(icon,startTime,duration)
	end
	if ( icon.updateTimer <= 0 ) and duration then
		icon.updateTimer = TELLMEWHEN_UPDATE_INTERVAL;
		if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
			icon:SetAlpha(icon.ConditionAlpha);
			icon.CondtShown = 0
			return;
		end
		local inrange = IsItemInRange(namefirst, "target");
		if ( not icon.RangeCheck or inrange == nil ) then
			inrange = 1;
		end
		if ( duration == 0 or GetGCD() == duration ) and inrange == 1 then
			icon.texture:SetVertexColor(1, 1, 1, 1);
			icon:SetAlpha(icon.usableAlpha);
		elseif ( icon.usableAlpha ~= 0 ) then
			if inrange ~= 1 then
				icon.texture:SetVertexColor(rc.r, rc.g, rc.b, 1);
				icon:SetAlpha(icon.unusableAlpha*rc.a);
			elseif not icon.ShowTimer then
				icon.texture:SetVertexColor(0.5, 0.5, 0.5, 1);
				icon:SetAlpha(icon.unusableAlpha);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
				icon:SetAlpha(icon.unusableAlpha);
			end
		else
			icon.texture:SetVertexColor(1, 1, 1, 1);
			icon:SetAlpha(icon.unusableAlpha);
		end
		icon.CondtShown = icon:GetAlpha()
		if icon.FakeHidden then
			icon:SetAlpha(0)
		end
	end
end

function TellMeWhen_Icon_Buff_OnUpdate(icon, elapsed)
	if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
		icon:SetAlpha(icon.ConditionAlpha);
		icon.CondtShown = 0
		return;
	end
	for i, iName in ipairs(icon.namelist) do
		local buffName, _, iconTexture, count, dispelType, duration, expirationTime = UnitAura(icon.Unit, icon.namenamelist[i], nil, icon.filter);
		if TMW.DS[iName] then
			for z=1,60 do --60 because i can and it breaks when there are no more buffs anyway
				buffName, _, iconTexture, count, dispelType, duration, expirationTime = UnitAura(icon.Unit, z, icon.filter);
				if (not buffName) or (dispelType == iName) then
					break;
				end
			end
			if icon.filterh and not buffName then
				for x=1,60 do
					buffName, _, iconTexture, count, dispelType, duration, expirationTime = UnitAura(icon.Unit, x, icon.filterh);
					if (not buffName) or (dispelType == iName) then
						break;
					end
				end
			end
		end
		if icon.filterh and not buffName then
			buffName, _, iconTexture, count, dispelType, duration, expirationTime = UnitAura(icon.Unit, icon.namenamelist[i], nil, icon.filterh);
		end
		if TMW.DSN[iName] then
			for z=1,60 do
				buffName, _, iconTexture, count, dispelType, duration, expirationTime,_,_,_,id = UnitAura(icon.Unit, z, icon.filter);
				if (not id) or (id == iName) then
					break;
				end
			end
			if icon.filterh and not buffName then
				for x=1,60 do --60 because i can and it breaks when there are no more buffs anyway
					buffName, _, iconTexture, count, dispelType, duration, expirationTime,_,_,_,id = UnitAura(icon.Unit, x, icon.filterh);
					if (not id) or (id == iName) then
						break;
					end
				end
			end
		end
		if icon.ShowPBar then
			PwrBarUpdate(icon,iName);
		end
		if ( buffName ) then
			if icon.Stacks and count and not (icon.StackMin <= count and count <= icon.StackMax) then
				icon:SetAlpha(0);
				icon.CondtShown = 0
				return;
			end
			icon.CondtShown = icon.presentAlpha
			if icon.FakeHidden then
				icon:SetAlpha(0)
				return;
			end
			if ( icon.texture:GetTexture() ~= iconTexture) then
				icon.texture:SetTexture(iconTexture);
				icon.learnedTexture = true;
			end
			icon:SetAlpha(icon.presentAlpha);

			if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
				icon.texture:SetVertexColor(pr.r, pr.g, pr.b, 1);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
			end
			if ( count > 1 ) then
				icon.countText:SetText(count);
			else
				icon.countText:SetText("");
			end
			if ( icon.ShowTimer and not UnitIsDead(icon.Unit)) then
				CooldownFrame_SetTimer(icon.Cooldown, expirationTime - duration, duration, 1);
			end
			if icon.ShowCBar then
				CDBarUpdate(icon, expirationTime - duration, duration,true)
			end
			return;
		end
	end

	icon.cooldownbar:SetValue(-1)

	icon:SetAlpha(icon.absentAlpha);
	if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
		icon.texture:SetVertexColor(ab.r, ab.g, ab.b, 1);
	else
		icon.texture:SetVertexColor(1, 1, 1, 1);
	end

	icon.countText:SetText("");
	if ( icon.ShowTimer  ) then
		CooldownFrame_SetTimer(icon.Cooldown, 0, 0, 0);
	end
	icon.CondtShown = icon.absentAlpha
	if icon.FakeHidden then
		icon:SetAlpha(0)
	end
end

function TellMeWhen_Icon_Reactive_OnUpdate(icon,elapsed)
	icon.updateTimer = icon.updateTimer - elapsed;
	local name = icon.namefirst
	local startTime, duration = GetSpellCooldown(name);
	if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
			icon:SetAlpha(icon.ConditionAlpha);
			icon.CondtShown = 0
			return;
		end
	if duration then
		if icon.ShowPBar then
			PwrBarUpdate(icon,name)
		end
		if icon.ShowCBar then
			CDBarUpdate(icon,startTime,duration)
		end
		if ( icon.updateTimer <= 0 ) and duration then
			icon.updateTimer = TELLMEWHEN_UPDATE_INTERVAL;
			if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
				icon:SetAlpha(icon.ConditionAlpha);
				icon.CondtShown = 0
				return;
			end
			local usable, nomana = IsUsableSpell(name);
			if icon.IsChakra then
				if UnitAura("player",GetSpellInfo(chakra[icon.IsChakra]["buffid"])) then
					usable = true
				else
					usable = false
				end
			end
			local inrange = IsSpellInRange(icon.namename, "target");
			local OnGCD = GetGCD() == duration and duration > 0;
			if ( not icon.RangeCheck or inrange == nil ) then
				inrange = 1
			end
			if not icon.ManaCheck then
				nomana = nil
			end
			local CD = false
			if icon.CooldownCheck then
				if not (duration == 0 or OnGCD) then
					CD = true
				end
			end
			if ( usable and not CD) then
				if( inrange == 1 and not nomana  ) then
					icon.texture:SetVertexColor(1,1,1,1)
					icon:SetAlpha(icon.usableAlpha)
				elseif ( inrange ~= 1 or nomana ) then
					if inrange ~= 1 then
						icon.texture:SetVertexColor(rc.r, rc.g, rc.b, 1);
						icon:SetAlpha(icon.usableAlpha*rc.a);
					elseif nomana then
						icon.texture:SetVertexColor(mc.r, mc.g, mc.b, 1);
						icon:SetAlpha(icon.usableAlpha*mc.a);
					end
				else
					icon.texture:SetVertexColor(1,1,1,1)
					icon:SetAlpha(icon.unusableAlpha)
				end
			else
				icon.texture:SetVertexColor(0.5,0.5,0.5,1)
				icon:SetAlpha(icon.unusableAlpha)
			end
		end
		icon.CondtShown = icon:GetAlpha()
		if icon.FakeHidden then
			icon:SetAlpha(0)
		end
	end
end

function TellMeWhen_Icon_WpnEnchant_OnEvent(icon, event, r)
	if (r == "player" ) then
		local slotID = GetInventorySlotInfo(icon.WpnEnchantType);
		if (not GetInventoryItemID("player",slotID)) and icon.HideUnequipped then
			icon:SetAlpha(0)
			icon:SetScript("OnUpdate", nil);
		else
			icon:SetScript("OnUpdate", TellMeWhen_Icon_WpnEnchant_OnUpdate);
		end
		local wpnTexture = GetInventoryItemTexture("player", slotID);
		if ( wpnTexture ) then
			icon.texture:SetTexture(wpnTexture);
		else
			icon.texture:SetTexture("Interface\\Icons\\INV_Misc_QuestionMark");
		end
	--	icon.startTime = icon.startTime or GetTime()
	end
end

function TellMeWhen_Icon_WpnEnchant_OnUpdate(icon, elapsed)
	icon.updateTimer = icon.updateTimer - elapsed;
	if ( icon.updateTimer <= 0 ) then
		icon.updateTimer = TELLMEWHEN_UPDATE_INTERVAL;
		if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
			icon:SetAlpha(icon.ConditionAlpha);
			icon.CondtShown = 0
			return;
		end
		local hasMH, mainHandExpiration, mainHandCharges, hasOH, offHandExpiration, offHandCharges, hasThrown, thrownExpiration, thrownCharges  = GetWeaponEnchantInfo();
		if ( icon.WpnEnchantType == "MainHandSlot" ) and ( hasMH ) then
			if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
				icon.texture:SetVertexColor(pr.r, pr.g, pr.b, 1);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
			end
			icon:SetAlpha(icon.presentAlpha);
			if ( mainHandCharges > 1 ) then
				icon.countText:SetText(mainHandCharges);
			else
				icon.countText:SetText("");
			end
			if icon.ShowTimer then
			--	if icon.startTime then
					CooldownFrame_SetTimer(icon.Cooldown, GetTime(), mainHandExpiration/1000, 1);
			--	else
			--		icon.startTime = GetTime();
			--	end
			end
		elseif ( icon.WpnEnchantType == "SecondaryHandSlot" ) and ( hasOH ) then
			if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
				icon.texture:SetVertexColor(pr.r, pr.g, pr.b, 1);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
			end
			icon:SetAlpha(icon.presentAlpha);
			if ( offHandCharges > 1 ) then
				icon.countText:SetText(offHandCharges);
			else
				icon.countText:SetText("");
			end
			if icon.ShowTimer then
			--	if icon.startTime then
					CooldownFrame_SetTimer(icon.Cooldown, GetTime(), offHandExpiration/1000, 1);
			--	else
			--		icon.startTime = GetTime();
			--	end
			end
		elseif ( icon.WpnEnchantType == "RangedSlot" ) and ( hasThrown ) then
			if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
				icon.texture:SetVertexColor(pr.r, pr.g, pr.b, 1);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
			end
			icon:SetAlpha(icon.presentAlpha);
			if ( thrownCharges > 1 ) then
				icon.countText:SetText(thrownCharges);
			else
				icon.countText:SetText("");
			end
			if icon.ShowTimer then
			--	if icon.startTime then
					CooldownFrame_SetTimer(icon.Cooldown, GetTime(), thrownExpiration/1000, 1);
			--	else
			--		icon.startTime = GetTime();
			--	end
			end
		else
			if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
				icon.texture:SetVertexColor(ab.r, ab.g, ab.b, 1);
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
			end
			icon:SetAlpha(icon.absentAlpha);
			CooldownFrame_SetTimer(icon.Cooldown, 0, 0, 0);
		end
		icon.CondtShown = icon:GetAlpha()
		if icon.FakeHidden then
			icon:SetAlpha(0)
		end
	end
end

function TellMeWhen_Icon_Totem_OnUpdate(icon, event, ...)
	for iSlot=1, 4 do
		local _, totemName, startTime, totemDuration, totemIcon = GetTotemInfo(iSlot)
		for i, iName in ipairs(icon.namelist) do
			if ( totemName and totemName:find(iName) ) then
				if icon.ShowPBar then
					PwrBarUpdate(icon,iName)
				end
				if icon.ShowCBar then
					CDBarUpdate(icon,startTime,totemDuration,1)
				end
				if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
					icon.texture:SetVertexColor(pr.r, pr.g, pr.b, 1);
				else
					icon.texture:SetVertexColor(1, 1, 1, 1);
				end
				icon:SetAlpha(icon.presentAlpha);

				if ( icon.texture:GetTexture() ~= totemIcon ) then
					icon.texture:SetTexture( totemIcon );
					icon.learnedTexture = true;
				end

				if ( icon.ShowTimer ) then
					CooldownFrame_SetTimer(icon.Cooldown, startTime, totemDuration, 1);
				end
				icon.CondtShown = icon.presentAlpha
				if icon.FakeHidden then
					icon:SetAlpha(0)
				end
				return
			end
		end
	end
	icon.texture:SetTexture( GetSpellTexture(icon.namename) );
	if ( icon.presentAlpha~= 0 ) and ( icon.absentAlpha~= 0) then
		icon.texture:SetVertexColor(ab.r, ab.g, ab.b, 1);
	else
		icon.texture:SetVertexColor(1, 1, 1, 1);
	end
	icon:SetAlpha(icon.absentAlpha);
	CooldownFrame_SetTimer(icon.Cooldown, 0, 0, 0);
	icon.CondtShown = icon.absentAlpha
	if icon.FakeHidden then
		icon:SetAlpha(0)
	end
end

function TellMeWhen_Icon_DarkSim_OnEvent(icon,event,...)
	if event == "ACTIONBAR_SLOT_CHANGED" then
		for i=1,120 do
			local type, spellID = GetActionInfo(i)
			if spellID == 77606 then
				icon.Slot = i
			end
		end
		return
	end
	local startTime, duration = GetActionCooldown(icon.Slot);
	if (not icon.ShowTimer) or ((not TellMeWhen_Settings["ClockGCD"]) and (GetGCD() == duration and duration > 0)) then return end
	if ( duration ) then
		CooldownFrame_SetTimer(icon.Cooldown, startTime, duration, 1);
	end
end

function TellMeWhen_Icon_DarkSim_OnUpdate(icon, elapsed)
	icon.updateTimer = icon.updateTimer - elapsed;
	local startTime, duration = GetActionCooldown(icon.Slot);
	if duration then
		if icon.ShowPBar then
			PwrBarUpdate(icon,77606)
		end
		if icon.ShowCBar then
			CDBarUpdate(icon,startTime,duration)
		end
		if ( icon.updateTimer <= 0 ) then
			icon.updateTimer = TELLMEWHEN_UPDATE_INTERVAL;
			icon.texture:SetTexture(GetActionTexture(icon.Slot) or "Interface\\Icons\\INV_Misc_QuestionMark");
			if ( icon.conditionPresent and not ConditionCheck(icon.Conditions) ) then
				icon:SetAlpha(icon.ConditionAlpha);
				icon.CondtShown = 0
				return;
			end
			local inrange = IsActionInRange(icon.Slot, "target");
			local _, nomana = IsUsableAction(icon.Slot);
			local OnGCD = GetGCD() == duration and duration > 0;
			local _,_,_,_,_,_,_,minRange,maxRange = GetSpellInfo(77606);
			if ( not icon.RangeCheck or not maxRange or inrange == nil ) then
				inrange = 1;
			end
			if not icon.ManaCheck then
				nomana = nil
			end

			if ( (duration == 0 or OnGCD) and inrange == 1 and not nomana) then
				icon.texture:SetVertexColor(1, 1, 1, 1);
				icon:SetAlpha(icon.usableAlpha);
			elseif ( icon.usableAlpha ~= 0) then
				if inrange ~= 1 then
					icon.texture:SetVertexColor(rc.r, rc.g, rc.b, 1);
					icon:SetAlpha(icon.unusableAlpha*rc.a);
				elseif nomana then
					icon.texture:SetVertexColor(mc.r, mc.g, mc.b, 1);
					icon:SetAlpha(icon.unusableAlpha*mc.a);
				elseif not icon.ShowTimer then
					icon.texture:SetVertexColor(0.5, 0.5, 0.5, 1);
					icon:SetAlpha(icon.unusableAlpha);
				else
					icon.texture:SetVertexColor(1, 1, 1, 1);
					icon:SetAlpha(icon.unusableAlpha);
				end
			else
				icon.texture:SetVertexColor(1, 1, 1, 1);
				icon:SetAlpha(icon.unusableAlpha);
			end
			icon.CondtShown = icon:GetAlpha()
			if icon.FakeHidden then
				icon:SetAlpha(0)
			end
		end
	end
end


do --Condition functions
	TMW_CNDT.HEALTH = function(condition)
		local percent = 100 * UnitHealth(condition.Unit)/UnitHealthMax(condition.Unit);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.DEFAULT = function(condition)
		local percent = 100 * UnitPower(condition.Unit)/UnitPowerMax(condition.Unit);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.MANA = function(condition)
		local percent = 100 * UnitPower(condition.Unit,0)/UnitPowerMax(condition.Unit,0);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.RAGE = function(condition)
		local percent = 100 * UnitPower(condition.Unit,1)/UnitPowerMax(condition.Unit,1);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.FOCUS = function(condition)
		local percent = 100 * UnitPower(condition.Unit,2)/UnitPowerMax(condition.Unit,2);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.ENERGY = function(condition)
		local percent = 100 * UnitPower(condition.Unit,3)/UnitPowerMax(condition.Unit,3);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.RUNIC_POWER = function(condition)
		local percent = 100 * UnitPower(condition.Unit,6)/UnitPowerMax(condition.Unit,6);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.HAPPINESS = function(condition)
		local number = GetPetHappiness() or 0
		return TMW_OP[condition.Operator](condition.Level, number);
	end;
	TMW_CNDT.SOUL_SHARDS = function(condition)
		local number = UnitPower("player",7);
		return TMW_OP[condition.Operator](condition.Level, number);
	end;
	TMW_CNDT.ECLIPSE = function(condition)
		local percent = 100 * UnitPower(condition.Unit,8)/UnitPowerMax(condition.Unit,8);
		return TMW_OP[condition.Operator](condition.Level, percent);
	end;
	TMW_CNDT.HOLY_POWER = function(condition)
		local number = UnitPower("player",9);
		return TMW_OP[condition.Operator](condition.Level, number);
	end;
	TMW_CNDT.ECLIPSE_DIRECTION = function(condition)
		if condition.Level <= 0 then return GetEclipseDirection() == "moon"  --  <= because it used to be -1 and i dont want to upgrade it
		elseif condition.Level == 1 then return GetEclipseDirection() == "sun"
		else return false end
	end;
	TMW_CNDT.ICON = function(condition)
		local icon = _G[condition.Icon]
		if icon then
			if condition.Level == 0 then return (icon:GetParent():IsShown() and ((icon.CondtShown or 0) > 0))
			elseif condition.Level == 1 then return (icon:GetParent():IsShown() and ((icon.CondtShown or 0) == 0))
			else return false end
		end
	end;
	TMW_CNDT.COMBO = function(condition)
		local number = GetComboPoints("player",condition.Unit)
		return TMW_OP[condition.Operator](condition.Level, number);
	end;
	TMW_CNDT.EXISTS = function(condition)
		return ((condition.Level == 1) == not UnitExists(condition.Unit)) --the not turns it into a true/false instead of 1/nil
	end;
	TMW_CNDT.ALIVE = function(condition)
		return (((condition.Level == 0) == (not UnitIsDeadOrGhost(condition.Unit))) and UnitExists(condition.Unit))
	end;
	TMW_CNDT.REACT = function(condition)
		if (UnitIsEnemy("player", condition.Unit)) or ((UnitReaction("player", condition.Unit) or 5) <= 4) then
			return condition.Level == 1;
		else
			return condition.Level == 2;
		end
	end;

	TMW_OP["=="] = function(level, percent)
		return percent == level;
	end
	TMW_OP["<"] = function(level, percent)
		return percent < level;
	end
	TMW_OP["<="] = function(level, percent)
		return percent <= level;
	end
	TMW_OP[">"] = function(level, percent)
		return percent > level;
	end
	TMW_OP[">="] = function(level, percent)
		return percent >= level;
	end
	TMW_OP["~="] = function(level, percent)
		return percent ~= level;
	end

	TMW_AO["OR"] = function(old,new)
		return (old or new)
	end
	TMW_AO["AND"] = function(old,new)
		return (old and new)
	end
end


-- -------------
-- NAME FUNCTIONS
-- -------------

function TellMeWhen_EquivToTable(name)
	local names, tab
	for k,v in pairs(TMW.BE) do
		if TMW.BE[k][name] then
			names = TMW.BE[k][name]
			break
		end
	end
	if not names then return false end
	if (names:find(";") ~= nil) then
		tab = { strsplit(";", names) }
	else
		tab =  { names }
	end
	for a,b in pairs(tab) do
		local new = strtrim(tostring(b))
		tab[a] = tonumber(new) or tostring(new)
	end
	return tab
end

function TellMeWhen_GetSpellNames(icon,setting,firstOnly,toname)
	local buffNames,buffNamesNames = {},{}
	local settings = TellMeWhen_SplitNames(setting)
	for k,v in pairs(settings) do
		local eqtt = TellMeWhen_EquivToTable(v)
		if eqtt then
			for z,x in pairs(eqtt) do
				tinsert(buffNames,x)
			end
		else
			tinsert(buffNames,v)
		end
	end
	icon.IsChakra = nil
	for k,v in pairs(chakra) do
		if GetSpellInfo(v.abid) == buffNames[1] then
			buffNames[1] = v.abid
			icon.IsChakra = k
		end
		if v.abid == tonumber(buffNames[1]) then
			icon.IsChakra = k
		end
	end
	if toname then
		if ( firstOnly ) then
			return GetSpellInfo(buffNames[1])
		else
			for k,v in pairs(buffNames) do
				buffNamesNames[k] = GetSpellInfo(buffNames[k]) or buffNames[k]
			end
			return buffNamesNames
		end
	end
	if ( firstOnly ) then
		return buffNames[1]
	end
	return buffNames
end

function TellMeWhen_GetItemIDs(icon,item,firstOnly)
	item = strtrim(tostring(item))
	local itemID = tonumber( item )
	if (not itemID) then
		local _,itemLink = GetItemInfo(item)
		if itemLink then
			_, _, itemID = strfind(itemLink, ":(%d+)")
		end
	elseif (itemID <= 19) then
		icon.Slot = itemID
		itemID = GetInventoryItemID("player",itemID)
	end
	return itemID or 0
end

function TellMeWhen_CleanString(text)
	text = strtrim(text,"; \t\r\n")
	while strfind(text," ;") do
		text = gsub(text," ;","; ")
	end
	while strfind(text,";  ") do
		text = gsub(text,";  ","; ")
	end
	while strfind(text,";;") do
		text = gsub(text,";;",";")
	end
	return text
end

function TellMeWhen_SplitNames(input)
	local buffNames = {}
	-- If input contains one or more semicolons, split the list into parts
	if (input:find(";")) then
		buffNames = { strsplit(";", input) }
	else
		buffNames = { input }
	end
	for a,b in pairs(buffNames) do --remove spaces from the beginning and end of each name
		local new = strtrim(tostring(b)) or error("Error removing spaces from:" .. a .. ":" .. b ..":.")
		buffNames[a] = tonumber(new) or tostring(new)
	end
	return buffNames
end


function TellMeWhen_SkinCallback(arg, SkinID, Gloss, Backdrop, Group, Button, Colors)
	if Group and SkinID then
		local groupID = tonumber(strmatch(Group,"%d+")) --Group is a string like "Group 5", so cant use :GetID()
		TellMeWhen_Settings.Groups[groupID]["LBF"]["SkinID"] = SkinID
		TellMeWhen_Settings.Groups[groupID]["LBF"]["Gloss"] = Gloss
		TellMeWhen_Settings.Groups[groupID]["LBF"]["Backdrop"] = Backdrop
		TellMeWhen_Settings.Groups[groupID]["LBF"]["Colors"] = Colors
	end
	if not TMW.DontRun then
		TellMeWhen_Update()
	else
		TMW.DontRun = false
	end
end














